#!/usr/bin/php
<?php

/*
 * (C) 2013-2020 iDorMobile, Werner Pfundstein IT
 *
 * Version: 2.3
 *
 */

    require_once("dbcore.php");

    if (!file_exists("/tmp/nocheck.txt")) {

        $flag = false;
        $arr = array();
        exec("/usr/sbin/asterisk -rx 'core show version'", $arr);
        if (count($arr) > 0) {
            if (substr($arr[0],0,12) == "Asterisk 1.8") {
                // Asterisk is running
            } else {
                $flag = true;
            }
        } else {
            $flag = true;
        }

        // check asterisk memory
        $arr = array();
        exec("ps aux | grep asterisk",$arr);
        $c = count($arr);
        if ($c > 1) {
            for ($i = 0; $i < $c; $i++) {
                $p = strpos($arr[$i],"/usr/sbin/asterisk");
                if ($p !== false) {
                    $pf = strpos($arr[$i],"  ");
                    while ($pf !== false) {
                        $arr[$i] = str_replace("  "," ",$arr[$i]);
                        $pf = strpos($arr[$i],"  ");
                    }
                    $ar = explode(" ",$arr[$i]);
                    $co = count($ar);
                    if ($co == 11) {
                        $v = intval($ar[3]);
                        if ($v > 50) {
                            $flag = true;
                        }
                    }
                }
            }
        }

        if ($flag) {
            $flag = false;
            exec("service asterisk stop");
            exec("killall asterisk");
            exec("service asterisk start");
        }

        if ($cn = db_open()) {
            // mysql is running
            db_close($cn);
        } else {
            echo "stop and start mysql\r\n";
            exec("service mysql stop");
            exec("killall mysql");
            exec("service mysql start");
        }

        $arr = array();
        exec("ps -e | grep apache2", $arr);
        if (count($arr) > 1) {
            // apache is running
        } else {
            echo "stop and start apache2\r\n";
            exec("service apache2 stop");
            exec("killall apache2");
            exec("service apache2 start");
        }

        $arr = array();
        exec("ps -e | grep idor_check_usb", $arr);
        if (count($arr) > 0) {
            // apache is running
        } else {
            echo "start idor_check_usb\r\n";
            exec("/usr/iDorMobile/system/scripts/idor_check_usb.php > /dev/null &");
        }

    }

?>
