<?php

/*
* (C) 2013-2020 iDorMobile LCC, Werner Pfundstein IT
*
* Version: 2.2
 *
 */

    require_once('/usr/iDorMobile/system/scripts/dbcore.php');

    if (session_status() == PHP_SESSION_NONE) {
        session_start();
    }

    $go_on = false;
    if (isset($_SESSION['user_level'])) {
        if (intval($_SESSION['user_level']) >= 10) {
            $go_on = true;
        }
    }

    if (!$go_on) {
        header("Location: index.php");
        exit;
    }


	$ret_value = "unknown";
	$error = "";

    if ($cn = db_open()) {
        if (isset($_POST['action'])) {
            if ($_POST['action'] == "run") {
                $number_start = intval(htmlentities($_POST['number_start']));
                $number_count = intval(htmlentities($_POST['number_count']));
                $android = intval(htmlentities($_POST['android']));
                $idm_phone = intval(htmlentities($_POST['idm_phone']));
                $ipad = intval(htmlentities($_POST['ipad']));
                $iphone = intval(htmlentities($_POST['iphone']));

                if (intval($number_count) == 0) {
                    $error .= "\nNumber of Apartments is 0";
                }
                if (intval($number_start) == 0) {
                    $error .= "Starting Apartment number is 0";
                }

                $total = 0;

                $total += intval($android);
                $total += intval($idm_phone);
                $total += intval($ipad);
                $total += intval($iphone);

                $lic = array();
                $lic['apartments'] = 0;
                $lic['used_apartments'] = 0;
                $lic['free_apartments'] = 0;

                $stmt = "Select value from settings where name='license_apartments'";
                if ($s = mysql_query($stmt)) {
                    if ($r = mysql_fetch_object($s)) {
                        $lic['apartments'] = $r->value;
                    }
                    mysql_free_result($s);
                }

                $stmt = "Select count(*) from apartments";
                if ($s = mysql_query($stmt)) {
                    if ($r = mysql_fetch_array($s)) {
                        $lic['used_apartments'] = $r[0];
                    }
                    mysql_free_result($s);
                }

                $lic['free_apartments'] = $lic['apartments'] - $lic['used_apartments'];

                if ($number_count > $lic['free_apartments']) {
                    $error .= "\nto many apartments. only ".$lic['free_apartments']." apartments free!";
                }

                if ($total > 10) {
                    $error .= "\nto many devices. max is 10!";
                }

                if (strlen($error) == 0) {
                    $ret_value = "ok";
                } else {
                    $ret_value = $error;
                }
            }
        }
        db_close($cn);
    }
	echo $ret_value;

?>
