<?php

/*
* (C) 2013-2020 iDorMobile LCC, Werner Pfundstein IT
*
* Version: 2.2
 *
 */

    require_once('/usr/iDorMobile/system/scripts/dbcore.php');

    if (session_status() == PHP_SESSION_NONE) {
        session_start();
    }

    $go_on = false;
    if (isset($_SESSION['user_level'])) {
        if (intval($_SESSION['user_level']) >= 30) {
            $go_on = true;
        }
    }

    if (!$go_on) {
        header("Location: index.php");
        exit;
    }

	$ret_value = "unknown";

    if ($cn = db_open()) {
        if (isset($_POST['action'])) {
            if ($_POST['action'] == "save") {
                $error = "";

                $id = intval(htmlentities($_POST['id']));
                $description = mysql_real_escape_string(htmlentities($_POST['description']));
                $filename_dest = mysql_real_escape_string(htmlentities($_POST['filename_dest']));

                if (strlen($description) == 0) {
                    $error .= "\n";
                    $error .= "Description is empty";
                }

                if (strlen($filename_dest) == 0) {
                    $error .= "\n";
                    $error .= "Destination File is empty";
                }

                if (strlen($error) > 0) {
                    $ret_value = $error;
                } else {
                    $ret_value = "ok";
                }
            }
        }
        db_close($cn);
    }

	echo $ret_value;

?>
